remove sed test garbage left behind on some hosts with an old/unsupported sed
[openwrt/staging/dedeckeh.git] / openwrt / scripts / ipkg
1 #!/bin/sh
2 # ipkg - the itsy package management system
3 #
4 # Copyright (C) 2001 Carl D. Worth
5 #
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2, or (at your option)
9 # any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
15
16 set -e
17
18 # By default do not do globbing. Any command wanting globbing should
19 # explicitly enable it first and disable it afterwards.
20 set -o noglob
21
22 ipkg_is_upgrade () {
23 local A B a b
24 A=$(echo $1 | sed -r "s/([0-9]+)[^[:alnum:]]*/ \1 /g").
25 B=$(echo $2 | sed -r "s/([0-9]+)[^[:alnum:]]*/ \1 /g").
26 while [ \! -z "$A" ] && [ \! -z "$B" ]; do {
27 set $A; a=$1; shift; A=$*
28 set $B; b=$1; shift; B=$*
29 [ "$a" -lt "$b" ] 2>&- && return 1
30 { [ "$a" -gt "$b" ] 2>&- || [ "$a" ">" "$b" ]; } && return
31 }; done
32 return 1
33 }
34
35 ipkg_srcs() {
36 local srcre="$1"
37 sed -ne "s/^src[[:space:]]\+$srcre[[:space:]]\+//p" < $IPKG_CONF
38 }
39
40 ipkg_src_names() {
41 sed -ne "s/^src[[:space:]]\+\([^[:space:]]\+\).*/\1/p" < $IPKG_CONF
42 }
43
44 ipkg_src_byname() {
45 local src="$1"
46 ipkg_srcs $src | head -n 1
47 }
48
49 ipkg_dests() {
50 local destre="`echo $1 | ipkg_protect_slashes`"
51 sed -ne "/^dest[[:space:]]\+$destre/{
52 s/^dest[[:space:]]\+[^[:space:]]\+[[:space:]]\+//
53 s/^/`echo $IPKG_OFFLINE_ROOT | ipkg_protect_slashes`/
54 p
55 }" < $IPKG_CONF
56 }
57
58 ipkg_dest_names() {
59 sed -ne "s/^dest[[:space:]]\+\([^[:space:]]\+\).*/\1/p" < $IPKG_CONF
60 }
61
62 ipkg_dests_all() {
63 ipkg_dests '.*'
64 }
65
66 ipkg_state_dirs() {
67 ipkg_dests_all | sed "s|\$|/$IPKG_DIR_PREFIX|"
68 }
69
70 ipkg_dest_default() {
71 ipkg_dests_all | head -n 1
72 }
73
74 ipkg_dest_default_name() {
75 ipkg_dest_names | head -n 1
76 }
77
78 ipkg_dest_byname() {
79 local dest="$1"
80 ipkg_dests $dest | head -n 1
81 }
82
83 ipkg_option() {
84 local option="$1"
85 sed -ne "s/^option[[:space:]]\+$option[[:space:]]\+//p" < $IPKG_CONF
86 }
87
88 ipkg_load_configuration() {
89 if [ -z "$IPKG_CONF_DIR" ]; then
90 IPKG_CONF_DIR=/etc
91 fi
92
93 IPKG_CONF="$IPKG_CONF_DIR/ipkg.conf"
94
95 if [ -z "$IPKG_OFFLINE_ROOT" ]; then
96 IPKG_OFFLINE_ROOT="`ipkg_option offline_root`"
97 fi
98 # Export IPKG_OFFLINE_ROOT for use by update-alternatives
99 export IPKG_OFFLINE_ROOT
100 if [ -n "$DEST_NAME" ]; then
101 IPKG_ROOT="`ipkg_dest_byname $DEST_NAME`"
102 if [ -z "$IPKG_ROOT" ]; then
103 if [ -d "$IPKG_OFFLINE_ROOT$DEST_NAME" ]; then
104 IPKG_ROOT="$IPKG_OFFLINE_ROOT$DEST_NAME";
105 else
106 echo "ipkg: invalid destination specification: $DEST_NAME
107 Valid destinations are directories or one of the dest names from $IPKG_CONF:" >&2
108 ipkg_dest_names >&2
109 return 1
110 fi
111 fi
112 else
113 IPKG_ROOT="`ipkg_dest_default`"
114 fi
115
116 # Global ipkg state directories
117 IPKG_DIR_PREFIX=usr/lib/ipkg
118 IPKG_LISTS_DIR=$IPKG_OFFLINE_ROOT/$IPKG_DIR_PREFIX/lists
119 IPKG_PENDING_DIR=$IPKG_OFFLINE_ROOT/$IPKG_DIR_PREFIX/pending
120 if [ -z "$IPKG_TMP" ]; then
121 IPKG_TMP=$IPKG_ROOT/tmp/ipkg
122 fi
123
124 [ -e "$IPKG_TMP" ] || mkdir -p $IPKG_TMP
125
126 # Destination specific ipkg meta-data directory
127 IPKG_STATE_DIR=$IPKG_ROOT/$IPKG_DIR_PREFIX
128
129 # Proxy Support
130 IPKG_PROXY_USERNAME="`ipkg_option proxy_username`"
131 IPKG_PROXY_PASSWORD="`ipkg_option proxy_password`"
132 IPKG_HTTP_PROXY="`ipkg_option http_proxy`"
133 IPKG_FTP_PROXY="`ipkg_option ftp_proxy`"
134 IPKG_NO_PROXY="`ipkg_option no_proxy`"
135 if [ -n "$IPKG_HTTP_PROXY" ]; then
136 export http_proxy="$IPKG_HTTP_PROXY"
137 fi
138
139 if [ -n "$IPKG_FTP_PROXY" ]; then
140 export ftp_proxy="$IPKG_FTP_PROXY"
141 fi
142
143 if [ -n "$IPKG_NO_PROXY" ]; then
144 export no_proxy="$IPKG_NO_PROXY"
145 fi
146
147 IPKG_STATUS_FIELDS='\(Package\|Status\|Essential\|Version\|Conffiles\|Root\)'
148 }
149
150 ipkg_usage() {
151 [ $# -gt 0 ] && echo "ipkg: $*"
152 echo "
153 usage: ipkg [options...] sub-command [arguments...]
154 where sub-command is one of:
155
156 Package Manipulation:
157 update Update list of available packages
158 upgrade Upgrade all installed packages to latest version
159 install <pkg> Download and install <pkg> (and dependencies)
160 install <file.ipk> Install package <file.ipk>
161 install <file.deb> Install package <file.deb>
162 remove <pkg> Remove package <pkg>
163
164 Informational Commands:
165 list List available packages and descriptions
166 files <pkg> List all files belonging to <pkg>
167 search <file> Search for a packaging providing <file>
168 info [pkg [<field>]] Display all/some info fields for <pkg> or all
169 status [pkg [<field>]] Display all/some status fields for <pkg> or all
170 depends <pkg> Print uninstalled package dependencies for <pkg>
171
172 Options:
173 -d <dest_name> Use <dest_name> as the the root directory for
174 -dest <dest_name> package installation, removal, upgrading.
175 <dest_name> should be a defined dest name from the
176 configuration file, (but can also be a directory
177 name in a pinch).
178 -o <offline_root> Use <offline_root> as the root for offline installation.
179 -offline <offline_root>
180
181 Force Options (use when ipkg is too smart for its own good):
182 -force-depends Make dependency checks warnings instead of errors
183 -force-defaults Use default options for questions asked by ipkg.
184 (no prompts). Note that this will not prevent
185 package installation scripts from prompting.
186 " >&2
187 exit 1
188 }
189
190 ipkg_dir_part() {
191 local dir="`echo $1 | sed -ne 's/\(.*\/\).*/\1/p'`"
192 if [ -z "$dir" ]; then
193 dir="./"
194 fi
195 echo $dir
196 }
197
198 ipkg_file_part() {
199 echo $1 | sed 's/.*\///'
200 }
201
202 ipkg_protect_slashes() {
203 sed -e 's/\//\\\//g'
204 }
205
206 ipkg_download() {
207 local src="$1"
208 local dest="$2"
209
210 local src_file="`ipkg_file_part $src`"
211 local dest_dir="`ipkg_dir_part $dest`"
212 if [ -z "$dest_dir" ]; then
213 dest_dir="$IPKG_TMP"
214 fi
215
216 local dest_file="`ipkg_file_part $dest`"
217 if [ -z "$dest_file" ]; then
218 dest_file="$src_file"
219 fi
220
221 # Proxy support
222 local proxyuser=""
223 local proxypassword=""
224 local proxyoption=""
225
226 if [ -n "$IPKG_PROXY_USERNAME" ]; then
227 proxyuser="--proxy-user=\"$IPKG_PROXY_USERNAME\""
228 proxypassword="--proxy-passwd=\"$IPKG_PROXY_PASSWORD\""
229 fi
230
231 if [ -n "$IPKG_PROXY_HTTP" -o -n "$IPKG_PROXY_FTP" ]; then
232 proxyoption="--proxy=on"
233 fi
234
235 echo "Downloading $src ..."
236 rm -f $IPKG_TMP/$src_file
237 case "$src" in
238 http://* | ftp://*)
239 if ! wget --passive-ftp $proxyoption $proxyuser $proxypassword -P $IPKG_TMP $src; then
240 echo "ipkg_download: ERROR: Failed to retrieve $src, returning $err"
241 return 1
242 fi
243 mv $IPKG_TMP/$src_file $dest_dir/$dest_file 2>/dev/null
244 ;;
245 file:/* )
246 ln -s `echo $src | sed 's/^file://'` $dest_dir/$dest_file 2>/dev/null
247 ;;
248 *)
249 echo "DEBUG: $src"
250 ;;
251 esac
252
253 echo "Done."
254 return 0
255 }
256
257 ipkg_update() {
258 if [ ! -e "$IPKG_LISTS_DIR" ]; then
259 mkdir -p $IPKG_LISTS_DIR
260 fi
261
262 local err=
263 for src_name in `ipkg_src_names`; do
264 local src="`ipkg_src_byname $src_name`"
265 if ! ipkg_download $src/Packages $IPKG_LISTS_DIR/$src_name; then
266 echo "ipkg_update: Error downloading $src/Packages to $IPKG_LISTS_DIR/$src_name" >&2
267 err=t
268 else
269 echo "Updated list of available packages in $IPKG_LISTS_DIR/$src_name"
270 fi
271 done
272
273 [ -n "$err" ] && return 1
274
275 return 0
276 }
277
278 ipkg_list() {
279 for src in `ipkg_src_names`; do
280 if ipkg_require_list $src; then
281 # black magic...
282 sed -ne "
283 /^Package:/{
284 s/^Package:[[:space:]]*\<\([a-z0-9.+-]*$1[a-z0-9.+-]*\).*/\1/
285 h
286 }
287 /^Description:/{
288 s/^Description:[[:space:]]*\(.*\)/\1/
289 H
290 g
291 s/\\
292 / - /
293 p
294 }
295 " $IPKG_LISTS_DIR/$src
296 fi
297 done
298 }
299
300 ipkg_extract_paragraph() {
301 local pkg="$1"
302 sed -ne "/Package:[[:space:]]*$pkg[[:space:]]*\$/,/^\$/p"
303 }
304
305 ipkg_extract_field() {
306 local field="$1"
307 # blacker magic...
308 sed -ne "
309 : TOP
310 /^$field:/{
311 p
312 n
313 b FIELD
314 }
315 d
316 : FIELD
317 /^$/b TOP
318 /^[^[:space:]]/b TOP
319 p
320 n
321 b FIELD
322 "
323 }
324
325 ipkg_extract_value() {
326 sed -e "s/^[^:]*:[[:space:]]*//"
327 }
328
329 ipkg_require_list() {
330 [ $# -lt 1 ] && return 1
331 local src="$1"
332 if [ ! -f "$IPKG_LISTS_DIR/$src" ]; then
333 echo "ERROR: File not found: $IPKG_LISTS_DIR/$src" >&2
334 echo " You probably want to run \`ipkg update'" >&2
335 return 1
336 fi
337 return 0
338 }
339
340 ipkg_info() {
341 for src in `ipkg_src_names`; do
342 if ipkg_require_list $src; then
343 case $# in
344 0)
345 cat $IPKG_LISTS_DIR/$src
346 ;;
347 1)
348 ipkg_extract_paragraph $1 < $IPKG_LISTS_DIR/$src
349 ;;
350 *)
351 ipkg_extract_paragraph $1 < $IPKG_LISTS_DIR/$src | ipkg_extract_field $2
352 ;;
353 esac
354 fi
355 done
356 }
357
358 ipkg_status_sd() {
359 [ $# -lt 1 ] && return 0
360 sd="$1"
361 shift
362 if [ -f $sd/status ]; then
363 case $# in
364 0)
365 cat $sd/status
366 ;;
367 1)
368 ipkg_extract_paragraph $1 < $sd/status
369 ;;
370 *)
371 ipkg_extract_paragraph $1 < $sd/status | ipkg_extract_field $2
372 ;;
373 esac
374 fi
375 return 0
376 }
377
378 ipkg_status_all() {
379 for sd in `ipkg_state_dirs`; do
380 ipkg_status_sd $sd $*
381 done
382 }
383
384 ipkg_status() {
385 if [ -n "$DEST_NAME" ]; then
386 ipkg_status_sd $IPKG_STATE_DIR $*
387 else
388 ipkg_status_all $*
389 fi
390 }
391
392 ipkg_status_matching_sd() {
393 local sd="$1"
394 local re="$2"
395 if [ -f $sd/status ]; then
396 sed -ne "
397 : TOP
398 /^Package:/{
399 s/^Package:[[:space:]]*//
400 s/[[:space:]]*$//
401 h
402 }
403 /$re/{
404 g
405 p
406 b NEXT
407 }
408 d
409 : NEXT
410 /^$/b TOP
411 n
412 b NEXT
413 " < $sd/status
414 fi
415 return 0
416 }
417
418 ipkg_status_matching_all() {
419 for sd in `ipkg_state_dirs`; do
420 ipkg_status_matching_sd $sd $*
421 done
422 }
423
424 ipkg_status_matching() {
425 if [ -n "$DEST_NAME" ]; then
426 ipkg_status_matching_sd $IPKG_STATE_DIR $*
427 else
428 ipkg_status_matching_all $*
429 fi
430 }
431
432 ipkg_status_installed_sd() {
433 local sd="$1"
434 local pkg="$2"
435 ipkg_status_sd $sd $pkg Status | grep -q "Status: install ok installed"
436 }
437
438 ipkg_status_installed_all() {
439 local ret=1
440 for sd in `ipkg_state_dirs`; do
441 if `ipkg_status_installed_sd $sd $*`; then
442 ret=0
443 fi
444 done
445 return $ret
446 }
447
448 ipkg_status_mentioned_sd() {
449 local sd="$1"
450 local pkg="$2"
451 [ -n "`ipkg_status_sd $sd $pkg Status`" ]
452 }
453
454 ipkg_files() {
455 local pkg="$1"
456 if [ -n "$DEST_NAME" ]; then
457 dests=$IPKG_ROOT
458 else
459 dests="`ipkg_dests_all`"
460 fi
461 for dest in $dests; do
462 if [ -f $dest/$IPKG_DIR_PREFIX/info/$pkg.list ]; then
463 dest_sed="`echo $dest | ipkg_protect_slashes`"
464 sed -e "s/^/$dest_sed/" < $dest/$IPKG_DIR_PREFIX/info/$pkg.list
465 fi
466 done
467 }
468
469 ipkg_search() {
470 local pattern="$1"
471
472 for dest_name in `ipkg_dest_names`; do
473 dest="`ipkg_dest_byname $dest_name`"
474 dest_sed="`echo $dest | ipkg_protect_slashes`"
475
476 set +o noglob
477 local list_files="`ls -1 $dest/$IPKG_DIR_PREFIX/info/*.list 2>/dev/null`"
478 set -o noglob
479 for file in $list_files; do
480 if sed "s/^/$dest_sed/" $file | grep -q $pattern; then
481 local pkg="`echo $file | sed "s/^.*\/\(.*\)\.list/\1/"`"
482 [ "$dest_name" != `ipkg_dest_default_name` ] && pkg="$pkg ($dest_name)"
483 sed "s/^/$dest_sed/" $file | grep $pattern | sed "s/^/$pkg: /"
484 fi
485 done
486 done
487 }
488
489 ipkg_status_remove_sd() {
490 local sd="$1"
491 local pkg="$2"
492
493 if [ ! -f $sd/status ]; then
494 mkdir -p $sd
495 touch $sd/status
496 fi
497 sed -ne "/Package:[[:space:]]*$pkg[[:space:]]*\$/,/^\$/!p" < $sd/status > $sd/status.new
498 mv $sd/status.new $sd/status
499 }
500
501 ipkg_status_remove_all() {
502 for sd in `ipkg_state_dirs`; do
503 ipkg_status_remove_sd $sd $*
504 done
505 }
506
507 ipkg_status_remove() {
508 if [ -n "$DEST_NAME" ]; then
509 ipkg_status_remove_sd $IPKG_STATE_DIR $*
510 else
511 ipkg_status_remove_all $*
512 fi
513 }
514
515 ipkg_status_update_sd() {
516 local sd="$1"
517 local pkg="$2"
518
519 ipkg_status_remove_sd $sd $pkg
520 ipkg_extract_field "$IPKG_STATUS_FIELDS" >> $sd/status
521 echo "" >> $sd/status
522 }
523
524 ipkg_status_update() {
525 ipkg_status_update_sd $IPKG_STATE_DIR $*
526 }
527
528 ipkg_unsatisfied_dependences() {
529 local pkg=$1
530 local deps="`ipkg_get_depends $pkg`"
531 local remaining_deps=
532 for dep in $deps; do
533 local installed="`ipkg_get_installed $dep`"
534 if [ "$installed" != "installed" ] ; then
535 remaining_deps="$remaining_deps $dep"
536 fi
537 done
538 ## echo "ipkg_unsatisfied_dependences pkg=$pkg $remaining_deps" > /dev/console
539 echo $remaining_deps
540 }
541
542 ipkg_safe_pkg_name() {
543 local pkg=$1
544 local spkg="`echo pkg_$pkg | sed -e y/-+./___/`"
545 echo $spkg
546 }
547
548 ipkg_set_depends() {
549 local pkg=$1; shift
550 local new_deps="$*"
551 pkg="`ipkg_safe_pkg_name $pkg`"
552 ## setvar ${pkg}_depends "$new_deps"
553 echo $new_deps > $IPKG_TMP/${pkg}.depends
554 }
555
556 ipkg_get_depends() {
557 local pkg=$1
558 pkg="`ipkg_safe_pkg_name $pkg`"
559 cat $IPKG_TMP/${pkg}.depends
560 ## eval "echo \$${pkg}_depends"
561 }
562
563 ipkg_set_installed() {
564 local pkg=$1
565 pkg="`ipkg_safe_pkg_name $pkg`"
566 echo installed > $IPKG_TMP/${pkg}.installed
567 ## setvar ${pkg}_installed "installed"
568 }
569
570 ipkg_set_uninstalled() {
571 local pkg=$1
572 pkg="`ipkg_safe_pkg_name $pkg`"
573 ### echo ipkg_set_uninstalled $pkg > /dev/console
574 echo uninstalled > $IPKG_TMP/${pkg}.installed
575 ## setvar ${pkg}_installed "uninstalled"
576 }
577
578 ipkg_get_installed() {
579 local pkg=$1
580 pkg="`ipkg_safe_pkg_name $pkg`"
581 if [ -f $IPKG_TMP/${pkg}.installed ]; then
582 cat $IPKG_TMP/${pkg}.installed
583 fi
584 ## eval "echo \$${pkg}_installed"
585 }
586
587 ipkg_depends() {
588 local new_pkgs="$*"
589 local all_deps=
590 local installed_pkgs="`ipkg_status_matching_all 'Status:.*[[:space:]]installed'`"
591 for pkg in $installed_pkgs; do
592 ipkg_set_installed $pkg
593 done
594 while [ -n "$new_pkgs" ]; do
595 all_deps="$all_deps $new_pkgs"
596 local new_deps=
597 for pkg in $new_pkgs; do
598 if echo $pkg | grep -q '[^a-z0-9.+-]'; then
599 echo "ipkg_depends: ERROR: Package name $pkg contains illegal characters (should be [a-z0-9.+-])" >&2
600 return 1
601 fi
602 # TODO: Fix this. For now I am ignoring versions and alternations in dependencies.
603 new_deps="$new_deps "`ipkg_info $pkg '\(Pre-\)\?Depends' | ipkg_extract_value | sed -e 's/([^)]*)//g
604 s/\(|[[:space:]]*[a-z0-9.+-]\+[[:space:]]*\)\+//g
605 s/,/ /g
606 s/ \+/ /g'`
607 ipkg_set_depends $pkg $new_deps
608 done
609
610 new_deps=`echo $new_deps | sed -e 's/[[:space:]]\+/\n/g' | sort | uniq`
611
612 local maybe_new_pkgs=
613 for pkg in $new_deps; do
614 if ! echo $installed_pkgs | grep -q "\<$pkg\>"; then
615 maybe_new_pkgs="$maybe_new_pkgs $pkg"
616 fi
617 done
618
619 new_pkgs=
620 for pkg in $maybe_new_pkgs; do
621 if ! echo $all_deps | grep -q "\<$pkg\>"; then
622 if [ -z "`ipkg_info $pkg`" ]; then
623 echo "ipkg_depends: Warning: $pkg mentioned in dependency but no package found in $IPKG_LISTS_DIR" >&2
624 ipkg_set_installed $pkg
625 else
626 new_pkgs="$new_pkgs $pkg"
627 ipkg_set_uninstalled $pkg
628 fi
629 else
630 ipkg_set_uninstalled $pkg
631 fi
632 done
633 done
634
635 echo $all_deps
636 }
637
638 ipkg_get_install_dest() {
639 local dest="$1"
640 shift
641 local sd=$dest/$IPKG_DIR_PREFIX
642 local info_dir=$sd/info
643
644 local requested_pkgs="$*"
645 local pkgs="`ipkg_depends $*`"
646
647 mkdir -p $info_dir
648 for pkg in $pkgs; do
649 if ! ipkg_status_mentioned_sd $sd $pkg; then
650 echo "Package: $pkg
651 Status: install ok not-installed" | ipkg_status_update_sd $sd $pkg
652 fi
653 done
654 ## mark the packages that we were directly requested to install as uninstalled
655 for pkg in $requested_pkgs; do ipkg_set_uninstalled $pkg; done
656
657 local new_pkgs=
658 local pkgs_installed=0
659 while [ -n "pkgs" ]; do
660 curcheck=0
661 ## echo "pkgs to install: {$pkgs}" > /dev/console
662 for pkg in $pkgs; do
663 curcheck="`expr $curcheck + 1`"
664 local is_installed="`ipkg_get_installed $pkg`"
665 if [ "$is_installed" = "installed" ]; then
666 echo "$pkg is installed" > /dev/console
667 continue
668 fi
669
670 local remaining_deps="`ipkg_unsatisfied_dependences $pkg`"
671 if [ -n "$remaining_deps" ]; then
672 new_pkgs="$new_pkgs $pkg"
673 ### echo "Dependences not satisfied for $pkg: $remaining_deps"
674 if [ $curcheck -ne `echo $pkgs|wc -w` ]; then
675 continue
676 fi
677 fi
678
679 local filename=
680 for src in `ipkg_src_names`; do
681 if ipkg_require_list $src; then
682 filename="`ipkg_extract_paragraph $pkg < $IPKG_LISTS_DIR/$src | ipkg_extract_field Filename | ipkg_extract_value`"
683 [ -n "$filename" ] && break
684 fi
685 done
686
687 if [ -z "$filename" ]; then
688 echo "ipkg_get_install: ERROR: Cannot find package $pkg in $IPKG_LISTS_DIR"
689 echo "ipkg_get_install: Check the spelling and maybe run \`ipkg update'."
690 ipkg_status_remove_sd $sd $pkg
691 return 1;
692 fi
693
694 echo ""
695 local tmp_pkg_file="$IPKG_TMP/"`ipkg_file_part $filename`
696 if ! ipkg_download `ipkg_src_byname $src`/$filename $tmp_pkg_file; then
697 echo "ipkg_get_install: Perhaps you need to run \`ipkg update'?"
698 return 1
699 fi
700
701 if ! ipkg_install_file_dest $dest $tmp_pkg_file; then
702 echo "ipkg_get_install: ERROR: Failed to install $tmp_pkg_file"
703 echo "ipkg_get_install: I'll leave it there for you to try a manual installation"
704 return 1
705 fi
706
707 ipkg_set_installed $pkg
708 pkgs_installed="`expr $pkgs_installed + 1`"
709 rm $tmp_pkg_file
710 done
711 ### echo "Installed $pkgs_installed package(s) this round"
712 if [ $pkgs_installed -eq 0 ]; then
713 if [ -z "$new_pkgs" ]; then
714 break
715 fi
716 fi
717 pkgs_installed=0
718 pkgs="$new_pkgs"
719 new_pkgs=
720 curcheck=0
721 done
722 }
723
724 ipkg_get_install() {
725 ipkg_get_install_dest $IPKG_ROOT $*
726 }
727
728 ipkg_install_file_dest() {
729 local dest="$1"
730 local filename="$2"
731 local sd=$dest/$IPKG_DIR_PREFIX
732 local info_dir=$sd/info
733
734 if [ ! -f "$filename" ]; then
735 echo "ipkg_install_file: ERROR: File $filename not found"
736 return 1
737 fi
738
739 local pkg="`ipkg_file_part $filename | sed 's/\([a-z0-9.+-]\+\)_.*/\1/'`"
740 local ext="`echo $filename | sed 's/.*\.//'`"
741 local pkg_extract_stdout
742 if [ "$ext" = "ipk" ]; then
743 pkg_extract_stdout="tar -xzOf"
744 elif [ "$ext" = "deb" ]; then
745 pkg_extract_stdout="ar p"
746 else
747 echo "ipkg_install_file: ERROR: File $filename has unknown extension $ext (not .ipk or .deb)"
748 return 1
749 fi
750
751 # Check dependencies
752 local depends="`ipkg_depends $pkg | sed -e "s/\<$pkg\>//"`"
753
754 # Don't worry about deps that are scheduled for installation
755 local missing_deps=
756 for dep in $depends; do
757 if ! ipkg_status_all $dep | grep -q 'Status:[[:space:]]install'; then
758 missing_deps="$missing_deps $dep"
759 fi
760 done
761
762 if [ ! -z "$missing_deps" ]; then
763 if [ -n "$FORCE_DEPENDS" ]; then
764 echo "ipkg_install_file: Warning: $pkg depends on the following uninstalled programs: $missing_deps"
765 else
766 echo "ipkg_install_file: ERROR: $pkg depends on the following uninstalled programs:
767 $missing_deps"
768 echo "ipkg_install_file: You may want to use \`ipkg install' to install these."
769 return 1
770 fi
771 fi
772
773 mkdir -p $IPKG_TMP/$pkg/control
774 mkdir -p $IPKG_TMP/$pkg/data
775 mkdir -p $info_dir
776
777 if ! $pkg_extract_stdout $filename ./control.tar.gz | (cd $IPKG_TMP/$pkg/control; tar -xzf - ) ; then
778 echo "ipkg_install_file: ERROR unpacking control.tar.gz from $filename"
779 return 1
780 fi
781
782 if [ -n "$IPKG_OFFLINE_ROOT" ]; then
783 if grep -q '^InstallsOffline:[[:space:]]*no' $IPKG_TMP/$pkg/control/control; then
784 echo "*** Warning: Package $pkg may not be installed in offline mode"
785 echo "*** Warning: Scheduling $filename for pending installation (installing into $IPKG_PENDING_DIR)"
786 echo "Package: $pkg
787 Status: install ok pending" | ipkg_status_update_sd $sd $pkg
788 mkdir -p $IPKG_PENDING_DIR
789 cp -f $filename $IPKG_PENDING_DIR
790 rm -r $IPKG_TMP/$pkg/control
791 rm -r $IPKG_TMP/$pkg/data
792 rmdir $IPKG_TMP/$pkg
793 return 0
794 fi
795 fi
796
797
798 echo -n "Unpacking $pkg..."
799 set +o noglob
800 for file in $IPKG_TMP/$pkg/control/*; do
801 local base_file="`ipkg_file_part $file`"
802 mv $file $info_dir/$pkg.$base_file
803 done
804 set -o noglob
805 rm -r $IPKG_TMP/$pkg/control
806
807 if ! $pkg_extract_stdout $filename ./data.tar.gz | (cd $IPKG_TMP/$pkg/data; tar -xzf - ) ; then
808 echo "ipkg_install_file: ERROR unpacking data.tar.gz from $filename"
809 return 1
810 fi
811 echo "Done."
812
813 echo -n "Configuring $pkg..."
814 export PKG_ROOT=$dest
815 if [ -x "$info_dir/$pkg.preinst" ]; then
816 if ! $info_dir/$pkg.preinst install; then
817 echo "$info_dir/$pkg.preinst failed. Aborting installation of $pkg"
818 rm -rf $IPKG_TMP/$pkg/data
819 rmdir $IPKG_TMP/$pkg
820 return 1
821 fi
822 fi
823
824 local old_conffiles="`ipkg_status_sd $sd $pkg Conffiles | ipkg_extract_value`"
825 local new_conffiles=
826 if [ -f "$info_dir/$pkg.conffiles" ]; then
827 for conffile in `cat $info_dir/$pkg.conffiles`; do
828 if [ -f "$dest/$conffile" ] && ! echo " $old_conffiles " | grep -q " $conffile "`md5sum $dest/$conffile | sed 's/ .*//'`; then
829 local use_maintainers_conffile=
830 if [ -z "$FORCE_DEFAULTS" ]; then
831 while true; do
832 echo -n "Configuration file \`$conffile'
833 ==> File on system created by you or by a script.
834 ==> File also in package provided by package maintainer.
835 What would you like to do about it ? Your options are:
836 Y or I : install the package maintainer's version
837 N or O : keep your currently-installed version
838 D : show the differences between the versions (if diff is installed)
839 The default action is to keep your current version.
840 *** `ipkg_file_part $conffile` (Y/I/N/O/D) [default=N] ? "
841 read response
842 case "$response" in
843 [YyIi] | [Yy][Ee][Ss])
844 use_maintainers_conffile=t
845 break
846 ;;
847 [Dd])
848 echo "
849 diff -u $dest/$conffile $IPKG_TMP/$pkg/data/$conffile"
850 diff -u $dest/$conffile $IPKG_TMP/$pkg/data/$conffile || true
851 echo "[Press ENTER to continue]"
852 read junk
853 ;;
854 *)
855 break
856 ;;
857 esac
858 done
859 fi
860 if [ -n "$use_maintainers_conffile" ]; then
861 local md5sum="`md5sum $IPKG_TMP/$pkg/data/$conffile | sed 's/ .*//'`"
862 new_conffiles="$new_conffiles $conffile $md5sum"
863 else
864 new_conffiles="$new_conffiles $conffile <custom>"
865 rm $IPKG_TMP/$pkg/data/$conffile
866 fi
867 else
868 md5sum="`md5sum $IPKG_TMP/$pkg/data/$conffile | sed 's/ .*//'`"
869 new_conffiles="$new_conffiles $conffile $md5sum"
870 fi
871 done
872 fi
873
874 local owd="`pwd`"
875 (cd $IPKG_TMP/$pkg/data/; tar cf - . | (cd $owd; cd $dest; tar xf -))
876 rm -rf $IPKG_TMP/$pkg/data
877 rmdir $IPKG_TMP/$pkg
878 rm -f $info_dir/$pkg.list
879 $pkg_extract_stdout $filename ./data.tar.gz | tar tzf - | sed -e 's/^\.//' > $info_dir/$pkg.list
880
881 if [ -x "$info_dir/$pkg.postinst" ]; then
882 $info_dir/$pkg.postinst configure
883 fi
884
885 if [ -n "$new_conffiles" ]; then
886 new_conffiles='Conffiles: '`echo $new_conffiles | ipkg_protect_slashes`
887 fi
888 local sed_safe_offline_root="`echo ${IPKG_OFFLINE_ROOT} | ipkg_protect_slashes`"
889 local sed_safe_root="`echo $dest | sed -e "s/^${sed_safe_offline_root}//" | ipkg_protect_slashes`"
890 sed -e "s/\(Package:.*\)/\1\\
891 Status: install ok installed\\
892 Root: ${sed_safe_root}\\
893 ${new_conffiles}/" $info_dir/$pkg.control | ipkg_status_update_sd $sd $pkg
894
895 rm -f $info_dir/$pkg.control
896 rm -f $info_dir/$pkg.conffiles
897 rm -f $info_dir/$pkg.preinst
898 rm -f $info_dir/$pkg.postinst
899
900 echo "Done."
901 }
902
903 ipkg_install_file() {
904 ipkg_install_file_dest $IPKG_ROOT $*
905 }
906
907 ipkg_install() {
908
909 while [ $# -gt 0 ]; do
910 local pkg="$1"
911 shift
912
913 case "$pkg" in
914 http://* | ftp://*)
915 local tmp_pkg_file="$IPKG_TMP/"`ipkg_file_part $pkg`
916 if ipkg_download $pkg $tmp_pkg_file; then
917 ipkg_install_file $tmp_pkg_file
918 rm $tmp_pkg_file
919 fi
920 ;;
921 file:/*.ipk | file://*.deb)
922 local ipkg_filename="`echo $pkg|sed 's/^file://'`"
923 ipkg_install_file $ipkg_filename
924 ;;
925 *.ipk | *.deb)
926 ipkg_install_file $pkg
927 ;;
928 *)
929 ipkg_get_install $pkg || true
930 ;;
931 esac
932 done
933 }
934
935 ipkg_install_pending() {
936 [ -n "$IPKG_OFFLINE_ROOT" ] && return 0
937
938 if [ -d "$IPKG_PENDING_DIR" ]; then
939 set +o noglob
940 local pending="`ls -1d $IPKG_PENDING_DIR/*.ipk 2> /dev/null`" || true
941 set -o noglob
942 if [ -n "$pending" ]; then
943 echo "The following packages in $IPKG_PENDING_DIR will now be installed:"
944 echo $pending
945 for filename in $pending; do
946 if ipkg_install_file $filename; then
947 rm $filename
948 fi
949 done
950 fi
951 fi
952 return 0
953 }
954
955 ipkg_install_wanted() {
956 local wanted="`ipkg_status_matching 'Status:[[:space:]]*install.*not-installed'`"
957
958 if [ -n "$wanted" ]; then
959 echo "The following package were previously requested but have not been installed:"
960 echo $wanted
961
962 if [ -n "$FORCE_DEFAULTS" ]; then
963 echo "Installing them now."
964 else
965 echo -n "Install them now [Y/n] ? "
966 read response
967 case "$response" in
968 [Nn] | [Nn][Oo])
969 return 0
970 ;;
971 esac
972 fi
973
974 ipkg_install $wanted
975 fi
976
977 return 0
978 }
979
980 ipkg_upgrade_pkg() {
981 local pkg="$1"
982 local avail_ver="`ipkg_info $pkg Version | ipkg_extract_value | head -n 1`"
983
984 is_installed=
985 for dest_name in `ipkg_dest_names`; do
986 local dest="`ipkg_dest_byname $dest_name`"
987 local sd=$dest/$IPKG_DIR_PREFIX
988 local inst_ver="`ipkg_status_sd $sd $pkg Version | ipkg_extract_value`"
989 if [ -n "$inst_ver" ]; then
990 is_installed=t
991
992 if [ -z "$avail_ver" ]; then
993 echo "Assuming locally installed package $pkg ($inst_ver) is up to date"
994 return 0
995 fi
996
997 if [ "$avail_ver" = "$inst_ver" ]; then
998 echo "Package $pkg ($inst_ver) installed in $dest_name is up to date"
999 elif ipkg_is_upgrade "$avail_ver" "$inst_ver"; then
1000 echo "Upgrading $pkg ($dest_name) from $inst_ver to $avail_ver"
1001 ipkg_get_install_dest $dest $pkg
1002 else
1003 echo "Not downgrading package $pkg from $inst_ver to $avail_ver"
1004 fi
1005 fi
1006 done
1007
1008 if [ -z "$is_installed" ]; then
1009 echo "Package $pkg does not appear to be installed"
1010 return 0
1011 fi
1012
1013 }
1014
1015 ipkg_upgrade() {
1016 if [ $# -lt 1 ]; then
1017 local pkgs="`ipkg_status_matching 'Status:.*[[:space:]]installed'`"
1018 else
1019 pkgs="$*"
1020 fi
1021
1022 for pkg in $pkgs; do
1023 ipkg_upgrade_pkg $pkg
1024 done
1025 }
1026
1027 ipkg_remove_pkg_dest() {
1028 local dest="$1"
1029 local pkg="$2"
1030 local sd=$dest/$IPKG_DIR_PREFIX
1031 local info_dir=$sd/info
1032
1033 if ! ipkg_status_installed_sd $sd $pkg; then
1034 echo "ipkg_remove: Package $pkg does not appear to be installed in $dest"
1035 if ipkg_status_mentioned_sd $sd $pkg; then
1036 echo "Purging mention of $pkg from the ipkg database"
1037 ipkg_status_remove_sd $sd $pkg
1038 fi
1039 return 1
1040 fi
1041
1042 echo "ipkg_remove: Removing $pkg... "
1043
1044 local files="`cat $info_dir/$pkg.list`"
1045
1046 export PKG_ROOT=$dest
1047 if [ -x "$info_dir/$pkg.prerm" ]; then
1048 $info_dir/$pkg.prerm remove
1049 fi
1050
1051 local conffiles="`ipkg_status_sd $sd $pkg Conffiles | ipkg_extract_value`"
1052
1053 local dirs_to_remove=
1054 for file in $files; do
1055 if [ -d "$dest/$file" ]; then
1056 dirs_to_remove="$dirs_to_remove $dest/$file"
1057 else
1058 if echo " $conffiles " | grep -q " $file "; then
1059 if echo " $conffiles " | grep -q " $file "`md5sum $dest/$file | sed 's/ .*//'`; then
1060 rm -f $dest/$file
1061 fi
1062 else
1063 rm -f $dest/$file
1064 fi
1065 fi
1066 done
1067
1068 local removed_a_dir=t
1069 while [ -n "$removed_a_dir" ]; do
1070 removed_a_dir=
1071 local new_dirs_to_remove=
1072 for dir in $dirs_to_remove; do
1073 if rmdir $dir >/dev/null 2>&1; then
1074 removed_a_dir=t
1075 else
1076 new_dirs_to_remove="$new_dirs_to_remove $dir"
1077 fi
1078 done
1079 dirs_to_remove="$new_dirs_to_remove"
1080 done
1081
1082 if [ -n "$dirs_to_remove" ]; then
1083 echo "ipkg_remove: Warning: Not removing the following directories since they are not empty:" >&2
1084 echo "$dirs_to_remove" | sed -e 's/\/[/]\+/\//g' >&2
1085 fi
1086
1087 if [ -x "$info_dir/$pkg.postrm" ]; then
1088 $info_dir/$pkg.postrm remove
1089 fi
1090
1091 ipkg_status_remove_sd $sd $pkg
1092 set +o noglob
1093 rm -f $info_dir/$pkg.*
1094 set -o noglob
1095
1096 echo "Done."
1097 }
1098
1099 ipkg_remove_pkg() {
1100 local pkg="$1"
1101 for dest in `ipkg_dests_all`; do
1102 local sd=$dest/$IPKG_DIR_PREFIX
1103 if ipkg_status_mentioned_sd $sd $pkg; then
1104 ipkg_remove_pkg_dest $dest $pkg
1105 fi
1106 done
1107 }
1108
1109 ipkg_remove() {
1110 while [ $# -gt 0 ]; do
1111 local pkg="$1"
1112 shift
1113 if [ -n "$DEST_NAME" ]; then
1114 ipkg_remove_pkg_dest $IPKG_ROOT $pkg
1115 else
1116 ipkg_remove_pkg $pkg
1117 fi
1118 done
1119 }
1120
1121 ###########
1122 # ipkg main
1123 ###########
1124
1125 # Parse options
1126 while [ $# -gt 0 ]; do
1127 arg="$1"
1128 case $arg in
1129 -d | -dest)
1130 [ $# -gt 1 ] || ipkg_usage "option $arg requires an argument"
1131 DEST_NAME="$2"
1132 shift
1133 ;;
1134 -o | -offline)
1135 [ $# -gt 1 ] || ipkg_usage "option $arg requires an argument"
1136 IPKG_OFFLINE_ROOT="$2"
1137 shift
1138 ;;
1139 -force-depends)
1140 FORCE_DEPENDS=t
1141 ;;
1142 -force-defaults)
1143 FORCE_DEFAULTS=t
1144 ;;
1145 -*)
1146 ipkg_usage "unknown option $arg"
1147 ;;
1148 *)
1149 break
1150 ;;
1151 esac
1152 shift
1153 done
1154
1155 [ $# -lt 1 ] && ipkg_usage "ipkg must have one sub-command argument"
1156 cmd="$1"
1157 shift
1158
1159 ipkg_load_configuration
1160 mkdir -p /tmp/ipkg
1161
1162 case "$cmd" in
1163 update|upgrade|list|info|status|install_pending)
1164 ;;
1165 install|depends|remove|files|search)
1166 [ $# -lt 1 ] && ipkg_usage "ERROR: the \`\`$cmd'' command requires an argument"
1167 ;;
1168 *)
1169 echo "ERROR: unknown sub-command \`$cmd'"
1170 ipkg_usage
1171 ;;
1172 esac
1173
1174 # Only install pending if we have an interactive sub-command
1175 case "$cmd" in
1176 upgrade|install)
1177 ipkg_install_pending
1178 ipkg_install_wanted
1179 ;;
1180 esac
1181
1182 ipkg_$cmd $*
1183 for a in `ls $IPKG_TMP`; do
1184 rm -rf $IPKG_TMP/$a
1185 done